local recipe = util.table.deepcopy(data.raw.recipe["gun-turret"])
recipe.name = "wd-gun-turret"
recipe.result = "wd-gun-turret"
recipe.enabled = false

local item = util.table.deepcopy(data.raw.item["gun-turret"])
item.name = "wd-gun-turret"
item.place_result = "wd-gun-turret"

local entity = util.table.deepcopy(data.raw["ammo-turret"]["gun-turret"])
entity.name= "wd-gun-turret"
entity.max_health = 800
entity.attack_parameters.cooldown=10
entity.attack_parameters.damage_modifier=1.6
entity.attack_parameters["range"]=24
entity.base_picture.layers[1].tint = {r = 0.7, g = 0.7, b = 0.7, a = 1}
--entity.prepared_animation.layers[1].stripes[1].tint = {r = 0.9, g = 0.1, b = 0.1, a = 1}
--entity.prepared_animation.layers[1].stripes[2].tint = {r = 0.9, g = 0.1, b = 0.1, a = 1}
--entity.attacking_animation.layers[1].stripes[1].tint = {r = 0.1, g = 0.1, b = 0.9, a = 1}
--entity.attacking_animation.layers[1].stripes[2].tint = {r = 0.1, g = 0.1, b = 0.9, a = 1}

table.insert(
   data.raw["technology"]["gun-turret-damage-1"].effects,
   {
        type = "turret-attack",
        turret_id = "wd-gun-turret",
        modifier = "0.1"
      }
)
table.insert(
   data.raw["technology"]["gun-turret-damage-2"].effects,
   {
        type = "turret-attack",
        turret_id = "wd-gun-turret",
        modifier = "0.1"
      }
)
table.insert(
   data.raw["technology"]["gun-turret-damage-3"].effects,
   {
        type = "turret-attack",
        turret_id = "wd-gun-turret",
        modifier = "0.2"
      }
)
table.insert(
   data.raw["technology"]["gun-turret-damage-4"].effects,
   {
        type = "turret-attack",
        turret_id = "wd-gun-turret",
        modifier = "0.2"
      }
)
table.insert(
   data.raw["technology"]["gun-turret-damage-5"].effects,
   {
        type = "turret-attack",
        turret_id = "wd-gun-turret",
        modifier = "0.2"
      }
)
table.insert(
   data.raw["technology"]["gun-turret-damage-6"].effects,
   {
        type = "turret-attack",
        turret_id = "wd-gun-turret",
        modifier = "0.4"
      }
)
table.insert(
   data.raw["technology"]["gun-turret-damage-7"].effects,
   {
        type = "turret-attack",
        turret_id = "wd-gun-turret",
        modifier = "0.7"
      }
)
	
	

local extend = {recipe, item, entity}
data:extend(extend)
