function wd_scenario(mode,version)
	local cleanse_group
	local cleansing = false
	
	function tablelength(T)
		local count = 0
		for _ in pairs(T) do count = count + 1 end
		return count
	end
	
	--if global.interface and global.interface["update_version"] then
	--	global.WD_version = 9
	--	global.send_satellite_round = global.interface["send_satellite_round"]
	--	global.wave_number = global.interface["wave_number"]
	--	global.send_satellite_ticks = global.interface["send_satellite_ticks"]
	--	global.skipped_multiplier = global.interface["skipped_multiplier"]
	--	global.wave_tick = global.interface["wave_tick"]
	--	global.money = global.interface["money"]
	--	global.team_upgrades = global.interface["team_upgrades"]
	--	global.on_tick_upgrade = global.interface["on_tick_upgrade"]
	--	global.silo = global.interface["silo"]
	--	global.force_bounty_modifier = global.interface["force_bounty_modifier"]
	--	global.bounty_bonus = global.interface["bounty_bonus"]
	--	global.round_button_visible = global.interface["round_button_visible"]
	--	global.wave_power = global.interface["wave_power"]
	--	global.spawn_tick = global.interface["spawn_tick"]
	--	global.end_spawn_tick = global.interface["end_spawn_tick"]
	--	global.spawns = global.interface["spawns"]
	--	global.waypoints = global.interface["waypoints"]
	--	global.initiated = true
	--end
	
	script.on_event( defines.events.on_console_chat, function(event)
		if event.player_index ==1 then
			if string.sub(string.lower(event.message),1, 7) == "wd wave" then
				global.wave_number = tonumber( string.sub( event.message, 9))
			end
			if string.sub(string.lower(event.message),1, 8) == "wd money" then
				global.money = tonumber( string.sub( event.message, 10))
			end
			if string.sub(string.lower(event.message),1, 18) == "wd satellite-round" then
				global.send_satellite_round = tonumber( string.sub( event.message, 20))
			end

		end
	end)
	
	
	
	--if WD_version <10 then
	--script.on_configuration_changed(function()
	--	global.on_tick_upgrade = 1
	--	if global.on_tick_upgrade == 1 then
	--		global.on_tick_upgrade = nil
	--	end
	--end)
	--script.on_init(function()
	--  init_globals()
	--  setup_waypoints()
	--  init_forces()
	--  game.map_settings.pollution.enabled = false
	--  randomize_ore()
	--  for k, force in pairs (game.forces) do
	--	force.manual_crafting_speed_modifier = force.manual_crafting_speed_modifier+1.5
	--	force.character_inventory_slots_bonus = math.floor(start_items_mult-1 )*5
	--  end
	--end)
	script.on_event(defines.events.on_player_created, function(event)
	  local player = game.players[event.player_index]
	  give_spawn_equipment(player)
	  give_starting_equipment(player)
	  if player.index == 1 then
		game.show_message_dialog({text = {"welcome-to-wave-defense"}})
	  else
		player.print({"welcome-to-wave-defense"})
	  end
	end)
	script.on_event(defines.events.on_player_joined_game, function(event)
	  local player = game.players[event.player_index]
	  gui_init(player)
	  --migration 0.16.8
		amount=player.get_inventory(defines.inventory.player_main).get_item_count("gun-turret")
		amount=amount+player.get_inventory(defines.inventory.player_quickbar).get_item_count("gun-turret")
		player.get_inventory(defines.inventory.player_main).remove({name="gun-turret",count=9999})
		player.get_inventory(defines.inventory.player_quickbar).remove({name="gun-turret",count=9999})
		if amount >0 then
			player.get_inventory(defines.inventory.player_main).insert({name="wd-gun-turret",count=math.max(1,amount)})
		end
	end)
	
	
	

	local increment = util.increment
	local format_number = util.format_number
	local format_time = util.formattime
	local levels = settings.startup["WD_waves"].value
	local constant_difficulty = settings.global["WD_constant_difficulty"].value
	local exponential_difficulty = settings.global["WD_exponential_difficulty"].value
	local difficulty = settings.startup["WD_difficulty"].value
	local ore_amount = settings.global["WD_ore_amount"].value
	local ore_size = settings.global["WD_ore_size"].value
	local wave_size_mult = settings.global["WD_wave_size"].value
	global.spawn_time = settings.global["WD_wave_duration"].value*60
	global.wave_time  = settings.global["WD_time_between_waves"].value*60
	local start_items_mult  = settings.global["WD_start_items"].value
	local preparation_time = settings.global["WD_preparation_time"].value*60
	--local maxhp = ((levels-16)*constant_difficulty+4000*math.pow(exponential_difficulty,levels-16))*difficulty
	local maxhp = ((levels-16)*300+4000*math.pow(1.1,levels-16))*difficulty
	levels = math.floor(math.log(maxhp / 160000)/math.log(2)+0.99)+6

	script.on_event(defines.events.on_runtime_mod_setting_changed, function(event)
	constant_difficulty = settings.global["WD_constant_difficulty"].value
	exponential_difficulty = settings.global["WD_exponential_difficulty"].value
	ore_amount = settings.global["WD_ore_amount"].value
	ore_size = settings.global["WD_ore_size"].value
	wave_size_mult = settings.global["WD_wave_size"].value
	global.spawn_time = settings.global["WD_wave_duration"].value*60
	global.wave_time  = settings.global["WD_time_between_waves"].value*60
	start_items_mult  = settings.global["WD_start_items"].value
	preparation_time = settings.global["WD_preparation_time"].value*60
	end)






	script.on_event(defines.events.on_rocket_launched, function(event)
	  local rocket = event.rocket
	  if rocket.get_item_count("satellite") > 0 then
		global.wave_number = global.send_satellite_round+5
		global.send_satellite_round = global.send_satellite_round +20
		global.send_satellite_ticks=0
		update_round_number()
		wave_end()
		update_connected_players()
		cleansing_group = game.surfaces[1].find_entities_filtered{force = "enemy"}
		local i = 0
		for _,enemy in ipairs(cleansing_group) do
			i=i+1
		end
		cleansing = true
	  else
		game.print({"no-satellite"})
	  end
	end)

	

	script.on_event(defines.events.on_entity_died, function(event)
	  local entity_type = event.entity.type
	  if entity_type == "unit" then
		unit_died(event)
		return
	  end
	  if entity_type == "rocket-silo" then
		rocket_died(event)
		return
	  end
	end)



	script.on_event(defines.events.on_player_respawned, function(event)
	  local player = game.players[event.player_index]
	  give_spawn_equipment(player)
	end)

	script.on_event(defines.events.on_gui_click, function(event)
	  local gui = event.element
	  local player = game.players[event.player_index]
	  if gui.name == "send_next_wave" then
		local skipped = math.floor(global.skipped_multiplier*(global.wave_tick - game.tick)*(1.15^global.wave_number))
		increment(global, "money", skipped)
		next_wave()
		if #game.players > 1 then
		  game.print({"sent-next-wave", player.name})
		else
		  game.print({"next-wave"})
		end
		update_connected_players()
		return
	  end
	  if gui.name == "upgrade_button" then
		create_upgrade_gui(player.gui.center)
		return
	  end
	  if gui.name == "wave_defense_visibility_button" then
		local gui =  mod_gui.get_frame_flow(player)
		gui.wave_frame.style.visible = not gui.wave_frame.style.visible
		return
	  end
	  if global.team_upgrades[gui.name] then
		local list = get_upgrades()
		local upgrades = global.team_upgrades
		local price = list[gui.name].price(upgrades[gui.name])
		if global.money >= price then
		  increment(global, "money", -price)
		  local sucess = false
		  for k, effect in pairs (list[gui.name].effect) do
			sucess = effect(event)
		  end
		  if sucess and (#game.players > 1) then
			game.print({"purchased-team-upgrade", player.name, list[gui.name].caption,upgrades[gui.name]})
		  end
		  update_connected_players()
		  for k, player in pairs (game.connected_players) do
			local gui = player.gui.center
			if gui.team_upgrade_frame then
			  update_upgrade_listing(gui.team_upgrade_frame.team_upgrade_scroll.upgrade_table, list, upgrades)
			end
		  end
		else
		  player.print({"not-enough-money"})
		end
		return
	  end
	end)

	script.on_event(defines.events.on_tick, function (event)

	if game.tick % 60 == 0 then
		if cleansing then
			local i = 0
			local health = math.max(5,((global.wave_number-16)*constant_difficulty+4000*math.pow(exponential_difficulty,global.wave_number-16))*difficulty)
			for entry, enemy in pairs(cleansing_group) do
				if not enemy.valid then 
					cleansing_group[entry] = nil 
				else
					enemy.damage(math.min(health,unit_config[enemy.name].max_health)/100,"player","acid")
					--game.players[1].print(unit_config[enemy.name].max_health)
					--if enemy.health == 0 then
					--	--enemy.die()
					--end
					i = i+1
				end
			end
			if i == 0 then cleansing = false end
		end
		
	end

	--migration
		if global.on_tick_upgrade ~=nil then
			if global.on_tick_upgrade % 2 == 0 then
				if global.team_upgrades["flamethrower-damage"] >0 then
					game.players[1].print("0.16.2: flamethrower damage updated")
					global.team_upgrades["flamethrower-damage"]=math.max(math.floor(global.team_upgrades["flamethrower-damage"] / 3),2)
					for k, force in pairs (game.forces) do
						force.set_ammo_damage_modifier("flamethrower", math.max(math.floor(force.get_ammo_damage_modifier("flamethrower")/3*5)/5,0.2))
						force.set_turret_attack_modifier("flamethrower-turret", math.max(math.floor(force.get_turret_attack_modifier("flamethrower-turret")/3*5)/5,0.2))
					end
				end
				global.on_tick_upgrade = global.on_tick_upgrade / 2
			end
			if global.on_tick_upgrade % 3 == 0 then
				for k, turret in pairs (game.surfaces[1].find_entities_filtered{name = "gun-turret"}) do
				
					local ammo = turret.get_inventory(defines.inventory.turret_ammo).get_contents()
					local coords= turret.position
					turret.destroy()
					local new = game.surfaces[1].create_entity({name="wd-gun-turret", position=coords, force = "player"})
					for a,b in pairs(ammo) do
						new.insert({name = a, count = b})
					end
				end  
				for k, force in pairs (game.forces) do
					force.recipes["gun-turret"].enabled = false
					force.recipes["wd-gun-turret"].enabled = true
					if force.recipes["lr-gun-turret"] then
						force.recipes["lr-gun-turret"].enabled = false
					end
				end
				amount=game.players[1].get_inventory(defines.inventory.player_main).get_item_count("gun-turret")
				amount=amount+game.players[1].get_inventory(defines.inventory.player_quickbar).get_item_count("gun-turret")
				game.players[1].get_inventory(defines.inventory.player_main).remove({name="gun-turret",count=9999})
				game.players[1].get_inventory(defines.inventory.player_quickbar).remove({name="gun-turret",count=9999})
				game.players[1].get_inventory(defines.inventory.player_main).insert({name="wd-gun-turret",count=math.max(1,amount)})
				global.on_tick_upgrade = global.on_tick_upgrade / 3
			end
		global.on_tick_upgrade = nil
		end
	--
		
		
	  local tick = event.tick
	  check_next_wave(tick)
	  check_spawn_units(tick)
	  if tick % 60 == 0 then
		update_connected_players()
	  end
	  if global.wave_number>=global.send_satellite_round then
	   increment(global, "send_satellite_ticks")
	   if global.send_satellite_ticks > 5400 then
		--global.send_satellite_ticks = math.pow(global.wave_number-global.send_satellite_round+2,0.35)*1440+(global.wave_number-global.send_satellite_round)*12
		global.send_satellite_ticks = math.min(4800,math.max((global.wave_number-global.send_satellite_round)*300+math.pow(global.wave_number-global.send_satellite_round,1.5)*60, math.pow(global.wave_number-global.send_satellite_round+1,2)*144+(global.wave_number-global.send_satellite_round+1)*180-math.pow(global.wave_number-global.send_satellite_round+1,2.3)*60))

		next_wave()
	   end
	  end
	  if event.tick %60 == 0 then
		  local update = function (gui, caption)
			if not gui.wave_frame then return end
			if not gui.wave_frame.next_level then return end
			local label = gui.wave_frame.next_level
			label.caption = caption
		  end

		  if global.wave_number >= global.send_satellite_round then
			  local caption = "Next Level: "..format_time(5400-global.send_satellite_ticks)
			  for k, player in pairs (game.connected_players) do
				update(mod_gui.get_frame_flow(player), caption)
			  end
		  else
			  local caption = ""
			  for k, player in pairs (game.connected_players) do
				update(mod_gui.get_frame_flow(player), caption)
			  end
		  end
	  end
	end)

	function init_forces()
	  for k, force in pairs (game.forces) do
		set_research(force)
		set_recipes(force)
		force.set_spawn_position(global.silo.position, game.surfaces[1])
		force.friendly_fire = false
	  end
	end

	function init_globals()
	  global.WD_version = version
	  global.wave_number = 0
	  global.wave_tick = preparation_time
	  global.force_bounty_modifier = 0.5
	  global.bounty_bonus = 1
	  global.skipped_multiplier = 0.1
	  global.round_button_visible = true
	  global.silo = game.surfaces[1].find_entities_filtered{name = "rocket-silo"}[1]
	  global.silo.minable = false
	  global.money = 0
	  global.send_satellite_round = 20
	  global.send_satellite_ticks = 0
	  global.team_upgrades = {}
	  init_unit_settings()
	  for name, upgrade in pairs (get_upgrades()) do
		global.team_upgrades[name] = 0
	  end
	end

	function init_unit_settings()
	  game.map_settings.unit_group.max_group_slowdown_factor = 1
	  game.map_settings.unit_group.max_member_speedup_when_behind = 2
	  game.map_settings.unit_group.max_member_slowdown_when_ahead = 0.8
	  game.map_settings.unit_group.member_disown_distance = 25
	  game.map_settings.unit_group.min_group_radius = 8.0
	  game.map_settings.path_finder.use_path_cache = true
	  game.map_settings.path_finder.max_steps_worked_per_tick = 300
	  game.map_settings.path_finder.short_cache_size = 50
	  game.map_settings.path_finder.long_cache_size = 50
	end

	function check_next_wave(tick)
	  if not global.wave_tick then return end
	  if global.wave_tick ~= tick then return end
	  game.print({"next-wave"})
	  next_wave()
	end

	function next_wave()
	  increment(global, "wave_number")
	  make_next_wave_tick()
	  make_next_spawn_tick()
	  local exponent = math.min(#game.connected_players, 8)
	  global.force_bounty_modifier = (0.5 * (1.15/(1.15^exponent)))
	  update_round_number()
	  global.wave_power = calculate_wave_power(global.wave_number)
	  next_round_button_visible(false)
	  local value = math.floor(100*((global.wave_number-1)%20+1)/20)
	  if global.silo.valid then
		global.silo.rocket_parts = 100
	  end

	  command_straglers()
	  spawn_units()
	end

	function calculate_wave_power(x)
	  local c = 1.65
	  local p = math.min(#game.connected_players, 8)
	  if x % 4 == 0 then
		return math.floor((1.15^p)*(x^c)*60)
	  elseif x % 2 == 0 then
		return math.floor((1.15^p)*(x^c)*50)
	  else
		return math.floor((1.15^p)*(x^c)*40)
	  end
	end

	function wave_end()
	  next_round_button_visible(true)
	  game.print({"wave-over"})
	  spawn_units()
	  global.spawn_tick = nil
	end

	function make_next_spawn_tick()
	  global.spawn_tick = game.tick + math.random(200, 300)
	end

	function check_spawn_units(tick)
	  if not global.spawn_tick then return end

	  if global.wave_number >= global.send_satellite_round then
		global.end_spawn_tick = tick+1
		global.wave_tick = tick+global.wave_time
		if (tick) % 250 == 0 then
		  if not global.silo.get_inventory(defines.inventory.rocket_silo_rocket) then
			global.silo.rocket_parts = 100
		  end
		end
	  end

	  if global.end_spawn_tick <= tick then
		wave_end()
		return
	  end

	  if global.spawn_tick == tick then
		spawn_units()
		make_next_spawn_tick()
	  end
	end

	function get_wave_units(x)
		local units = {}
		local k = 1
		local health = ((x-16)*constant_difficulty+4000*math.pow(exponential_difficulty,x-16))*difficulty
		if x>=23 and health > 10000 then
			for unit_name, unit in pairs (unit_config) do
				if unit.in_wave(health) then
					units[k] = {name = unit_name, cost = unit.cost}
					k = k + 1
				end
			end
		elseif x<=23 and health > 10000 then
			for unit_name, unit in pairs (unit_config) do
				if unit.in_wave(health) or unit.in_wave(x) then
					units[k] = {name = unit_name, cost = unit.cost}
					k = k + 1
				end
			end
		else
			for unit_name, unit in pairs (unit_config) do
				if unit.in_wave(x) then
					units[k] = {name = unit_name, cost = unit.cost}
					k = k + 1
				end
			end
		end
		return units
	end

	function spawn_units()

	  local rand = math.random
	  local surface = game.surfaces[1]
	  if surface.count_entities_filtered{type = "unit"} > 500 then return end
	  local power = 0+global.wave_power
	  local spawns = global.spawns
	  local spawns_count = #spawns
	  local units = get_wave_units(global.wave_number)
	  local wave_size = math.floor((math.random(5,6)+math.random()+math.min(#game.connected_players, 8)*1.8)*wave_size_mult)
	  local units_length = #units
	  local groups = {}
	  local group_count = 1
	  local new_group = true
	  local spawn
	  local unit_count
	  local group
	  local temp
	  local hp = ((global.wave_number-16)*constant_difficulty+4000*math.pow(exponential_difficulty,global.wave_number-16))*difficulty
	  local behemoths = math.floor(((global.wave_number - global.send_satellite_round)/16+0.5)*wave_size)
	  local k
	  local biter
	  local cost
	  
	  while units_length > 0 and wave_size > 0 do
		if new_group == true then
		  spawn = spawns[rand(spawns_count)]
		  group = surface.create_unit_group{position = spawn}
		  groups[group_count] = group; group_count = group_count + 1
		  new_group = false
		  unit_count = 0
		end
		if global.wave_number < 20 or global.send_satellite_round > 20 then
			k = rand(units_length)
			biter = units[k]

		else

			k = rand(2)
			if behemoths > 0 then
				biter = units[k+2]
				behemoths = behemoths - 1
			else
				biter = units[k]
			end
		end
		cost = biter.cost
		
		if cost > power or wave_size <= 0 then
		  table.remove(units, k)
		  units_length = units_length - 1
		else
		  local position = surface.find_non_colliding_position(biter.name, spawn, 32, 2)
		  if position then
			if unit_count <= 500 then
			  temp = surface.create_entity{name = biter.name, position = position}
			  if temp.health>3000 then
				if string.sub(biter.name,13,19)== "spitter" then
					temp.health = math.min(temp.health, hp/2)
				else
					temp.health = math.min(temp.health, hp)
				end
			  end
			  
			  group.add_member(temp)
			  
			  
			  if global.wave_number<20 and hp < 10000 then
				power = power-cost
			  else
				wave_size = wave_size -1
			  end
			  
			  unit_count = unit_count + 1
			else
			  new_group = true
			end
		  else
			break
		  end
		end
	  end
	  set_command(groups)
	end

	function randomize_ore()
	  local surface = game.surfaces[1]
	  local rand = math.random
	  
	  
	  local ores = surface.find_entities_filtered{type = "resource"}
	  for k, ore in pairs (ores) do
		if #game.surfaces[1].find_entities_filtered{area={{ore.position.x-1, ore.position.y-1},{ore.position.x+1, ore.position.y+1}}, type= "resource"} == 9 then
			ores[k]=nil
		end
	  end  
	  if ore_size <=12 then
		  for k, ore in pairs (ores) do
			if ore.name == "copper-ore" then
				enlarge_ore(ore)
			end
		  end
		  
		  for k, ore in pairs (ores) do
			if ore.name ~= "copper-ore" and ore.name ~= "coal" and ore.name ~= "stone" then
			enlarge_ore(ore)
			end
		  end
	  else
		  for k, ore in pairs (ores) do
			if ore.name ~= "coal" and ore.name ~= "stone" then
			enlarge_ore(ore)
			end
		  end
	  end
	  
	  for k, ore in pairs (ores) do
		if ore.name == "coal" or ore.name == "stone" then
		enlarge_ore(ore)
		end
	  end  
	  
		local trees = surface.find_entities_filtered{area={{-216,138},{-116,223}}, type = "tree"}
		local trees_bak={}
		for k, tree in pairs (trees) do
		trees_bak[k]={}
		trees_bak[k]["x"]=tree.position.x
		trees_bak[k]["y"]=tree.position.y
		trees_bak[k]["name"]=tree.name
		tree.destroy()
		end
		
		local ores = surface.find_entities_filtered{area={{-216,138},{-116,223}}, type = "resource"}
		local ores2={}
		for k, ore in pairs (ores) do
			if #game.surfaces[1].find_entities_filtered{area={{ore.position.x-1, ore.position.y-1},{ore.position.x+2, ore.position.y+2}}, name=ore.name, invert=true} > 0 then
				table.insert(ores2, ore)
			end
		end  
		
		for k, ore in pairs (ores2) do
			ore.destroy()
		end
		
		for k,tree in pairs(trees_bak) do
			game.surfaces[1].create_entity({name=tree["name"], position={tree["x"], tree["y"]}})
		end
	  
	  for k, ore in pairs (surface.find_entities_filtered{type = "resource"}) do
		if ore.name ~= "crude-oil" then
			ore.amount = (ore.amount + rand(-5,5))+rand(100,125)*(ore_size+ore_amount)
		else
			ore.amount = (ore.amount + rand(-5,5))*(1+ore_amount)
		end
	  end
	end

	function enlarge_ore(ore)
		if ore.name ~= "crude-oil" then
			for y=-ore_size,ore_size do
				for x=-ore_size,ore_size do
					if #game.surfaces[1].find_entities_filtered{position={ore.position.x+x, ore.position.y+y}, type= "resource"} < 1 then
					 game.surfaces[1].create_entity({name=ore.name, amount=ore.amount, position={ore.position.x+x, ore.position.y+y}})
					end
				end
			end
		end
	end

	function set_command(groups)
	  if not global.silo then return end
	  if not global.silo.valid then return end
	  local waypoints = global.waypoints
	  local num_waypoints = #waypoints
	  local rand = math.random
	  local def = defines
	  local compound = def.command.compound
	  local structure = def.compound_command.return_last
	  local go_to = def.command.go_to_location
	  local attack = def.command.attack
	  local target = global.silo
	  for k, group in pairs (groups) do
		group.set_command
		{
		  type = compound,
		  structure_type = structure,
		  commands =
		  {
			{type = go_to, destination = waypoints[rand(num_waypoints)]},
			{type = attack, target = target}
		  }
		}
	  end
	end

	function command_straglers()
	  local command = {type = defines.command.attack, target = global.silo}
	  for k, unit in pairs (game.surfaces[1].find_entities_filtered({type = "unit"})) do
		if not unit.unit_group then
		  unit.set_command(command)
		end
	  end
	end

	unit_config =
	  {
		["wd-small-biter"] =      		{max_health = 30*difficulty,bounty = 40, cost = 20, in_wave = function(x) return (x<=6) end},
		["wd-small-spitter"] =    		{max_health = 20*difficulty,bounty = 60, cost = 40, in_wave = function(x) return (x>=4) and (x<=9) end},
		["wd-medium-biter"] =     		{max_health = 150*difficulty,bounty = 240, cost = 160 , in_wave = function(x) return (x>=6) and (x<=11) end},
		["wd-medium-spitter"] =   		{max_health = 100*difficulty,bounty = 100, cost = 240, in_wave = function(x) return (x>=8) and (x<=13) end},
		["wd-big-biter"] =        		{max_health = 900*difficulty,bounty = 800, cost = 600, in_wave = function(x) return (x>=12) and (x<=20 or global.send_satellite_round == 20) end},
		["wd-big-spitter"] =      		{max_health = 400*difficulty,bounty = 400, cost = 800, in_wave = function(x) return (x>=14) and (x<=20 or global.send_satellite_round == 20) end},
		["wd-behemoth-biter"] =   		{max_health = 10000,bounty = 2400, cost = 1600, in_wave = function(x) return (x>=16) and (x<=10000) end},
		["wd-behemoth-biter-mk2"] =   	{max_health = 20000,bounty = 3000, cost = 1700, in_wave = function(x) return (x>=10000) and (x<=20000) end},
		["wd-behemoth-biter-mk3"] =   	{max_health = 40000,bounty = 3500, cost = 1800, in_wave = function(x) return (x>=20000) and (x<=40000) end},
		["wd-behemoth-biter-mk4"] =   	{max_health = 80000,bounty = 4100, cost = 1900, in_wave = function(x) return (x>=40000) and (x<=80000) end},
		["wd-behemoth-biter-mk5"] =   	{max_health = 160000,bounty = 4800, cost = 2000, in_wave = function(x) return (x>=80000) end},
		["wd-behemoth-spitter"] = 		{max_health = 5000,bounty = 1000, cost = 1300, in_wave = function(x) return (x>=18) and (x<=10000) end},
		["wd-behemoth-spitter-mk2"] = 	{max_health = 10000,bounty = 1150, cost = 1400, in_wave = function(x) return (x>=10000) and (x<=20000) end},
		["wd-behemoth-spitter-mk3"] = 	{max_health = 20000,bounty = 1350, cost = 1500, in_wave = function(x) return (x>=20000) and (x<=40000) end},
		["wd-behemoth-spitter-mk4"] = 	{max_health = 40000,bounty = 1600, cost = 1600, in_wave = function(x) return (x>=40000) and (x<=80000) end},
		["wd-behemoth-spitter-mk5"] = 	{max_health = 80000,bounty = 1850, cost = 1700, in_wave = function(x) return (x>=80000) end},
	  }
	  if levels>=6 then
		  unit_config["wd-behemoth-biter-mk5"] =   {max_health = 160000,bounty = 5400, cost = 2000, in_wave = function(x) return (x>=80000) and (x<=160000) end}
		  unit_config["wd-behemoth-spitter-mk5"] = {max_health = 80000,bounty = 2150, cost = 1700, in_wave = function(x) return (x>=80000) and (x<=160000) end}
	  end
	  
	  for i=6, math.min(48,levels) do
		  unit_config["wd-behemoth-biter-mk"..tostring(i)] = {max_health = 160000*math.pow(2,i-5),bounty = 5400*math.pow(1/6+1,i-5), cost = 1500, in_wave = function(x) return (x>=160000*math.pow(2,i-6)) and (x<=160000*math.pow(2,i-5)) end}
		  unit_config["wd-behemoth-spitter-mk"..tostring(i)] = {max_health = 80000*math.pow(2,i-5),bounty = 2150*math.pow(1/6+1,i-5), cost = 1200, in_wave = function(x) return (x>=160000*math.pow(2,i-6)) and (x<=160000*math.pow(2,i-5)) end}
	  end
	 
	 
	function make_next_wave_tick()
	  global.end_spawn_tick = game.tick + global.spawn_time
	  global.wave_tick  = global.end_spawn_tick + global.wave_time
	end

	function time_to_next_wave()
	  if not global.wave_tick then return end
	  return format_time(global.wave_tick - game.tick)
	end

	function time_to_wave_end()
	  if not global.end_spawn_tick then return end
	  return format_time(global.end_spawn_tick - game.tick)
	end

	function rocket_died(event)
	  local silo = event.entity
	  if silo == global.silo then
		game.set_game_state{game_finished = true, player_won = false, can_continue = false}
	  end
	end

	function unit_died(event)
	
	  local force = event.force
	  if not force then return end
	  if not force.valid then return end
	  
	  local died = event.entity
	  local surface = died.surface
	  local cash
	  if cleansing then
		cash = math.floor(get_bounty_price(died.name)*global.force_bounty_modifier*global.bounty_bonus/2)
	  else
		cash = math.floor(get_bounty_price(died.name)*global.force_bounty_modifier*global.bounty_bonus)
	  end
	  increment(global, "money", cash)
	  surface.create_entity{name = "flying-text", position = died.position, text = "+"..cash, color = {r = 0.2, g = 0.8, b = 0.2, a = 0.2}}
	  if global.wave_number < 20 then return end
	  for k, belt in pairs (surface.find_entities_filtered{area = died.bounding_box, type = "transport-belt", limit = 1}) do
		belt.damage(50, "enemy")
	  end
	end

	function get_bounty_price(name)
	  if not unit_config[name] then game.print(name.." not in config") return 0 end
	  if not unit_config[name].bounty then game.print(name.." not in bounty list") return 0 end
	  return unit_config[name].bounty
	end

	function setup_waypoints()
	  local surface = game.surfaces[1]
	  local w = surface.map_gen_settings.width
	  local threshold = -((5*w)/8)
	  local spawns = {}
	  local waypoints = {}
	  for k, entity in pairs (surface.find_entities_filtered{name = "big-worm-turret"}) do
		local position = entity.position
		local X = position.x
		local Y = position.y
		local I = Y-X
		if I > threshold then
		  table.insert(waypoints, position)
		else
		  table.insert(spawns, position)
		end
		entity.destroy()
	  end
	  global.waypoints = waypoints
	  global.spawns = spawns
	end

	function insert_items(entity, array)
	  for name, count in pairs (array) do
		entity.insert({name = name, count = count})
	  end
	end

	if mode == "sp" then
	
		function give_starting_equipment(player)
			local items =
			{
				["iron-plate"] = math.floor(400*start_items_mult*(2/(1+start_items_mult))),
				["pipe"] = math.floor(400*start_items_mult*(2/(1+start_items_mult))),
				["pipe-to-ground"] = math.floor(100*start_items_mult*(2/(1+start_items_mult))),
				["copper-plate"] = math.floor(400*start_items_mult*(2/(1+start_items_mult))),
				["steel-plate"] = math.floor(600*start_items_mult*(2/(1+start_items_mult))),
				["iron-gear-wheel"] = math.floor(400*start_items_mult*(2/(1+start_items_mult))),
				["transport-belt"] = math.floor(1000*start_items_mult*(2/(1.5+0.5*start_items_mult))),
				["underground-belt"] = math.floor(60*start_items_mult*(2/(1+start_items_mult))),
				["splitter"] = math.floor(60*start_items_mult*(2/(1+start_items_mult))),
				["wd-gun-turret"] = math.floor(24*start_items_mult),
				["stone-wall"] = math.floor(150*start_items_mult),
				["repair-pack"] = math.floor(20*start_items_mult*(2/(1+start_items_mult))),
				["inserter"] = math.floor(200*start_items_mult*(2/(1.5+0.5*start_items_mult))),
				["burner-inserter"] = 50,
				["small-electric-pole"] = 50,
				["medium-electric-pole"] = math.floor(200*start_items_mult*(2/(1+start_items_mult))),
				["big-electric-pole"] = math.floor(30*start_items_mult*(2/(1+start_items_mult))),
				["burner-mining-drill"] = 50,
				["electric-mining-drill"] = math.floor(150*start_items_mult*(2/(1+start_items_mult))),
				["stone-furnace"] = 35,
				["steel-furnace"] = math.floor(60*start_items_mult*(2/(1+start_items_mult))),
				["electric-furnace"] = math.floor(20*start_items_mult),
				["assembling-machine-1"] = 50,
				["assembling-machine-2"] = math.floor(40*start_items_mult*(2/(1+start_items_mult))),
				["assembling-machine-3"] = math.floor(40*start_items_mult),
				["electronic-circuit"] = math.floor(400*start_items_mult*(2/(1+start_items_mult))),
				["fast-inserter"] = math.floor(200*start_items_mult*(2/(1.5+0.5*start_items_mult))),
				["long-handed-inserter"] = math.floor(200*start_items_mult*(2/(1+start_items_mult))),
				["substation"] = math.floor(20*start_items_mult*(2/(1+start_items_mult))),
				["boiler"] = 20,
				["offshore-pump"] = 2,
				["steam-engine"] = 40,
				["chemical-plant"] = 20,
				["oil-refinery"] = 5,
				["pumpjack"] = 20,
				["small-lamp"] = 20,
				["advanced-circuit"] = math.floor(20*start_items_mult),
				["stone-brick"] = math.floor(100*start_items_mult),

			}
				if start_items_mult >=2 then
		
					items["assembling-machine-1"]=nil
					items["stone-furnace"] = math.min(50,items["stone-furnace"])
		
				end
			
			insert_items(player, items)
		end
	
		function give_spawn_equipment(player)
			local items =
				{
				["steel-axe"] = 6,
				["submachine-gun"] = 1,
				["wd-yellow-ammo"] = math.floor(80*start_items_mult),
				["shotgun"] = 1,
				["shotgun-shell"] = 20,
				["power-armor-mk2"] = 1,
				["construction-robot"] = 60,
				["blueprint"] = 1,
				["deconstruction-planner"] = 1
				}
			insert_items(player, items)
			local equipment =
				{
				"fusion-reactor-equipment",
				"fusion-reactor-equipment",
				"exoskeleton-equipment",
				"personal-roboport-mk2-equipment",
				"personal-roboport-mk2-equipment",
				"night-vision-equipment",
				"battery-mk2-equipment"
				}
			local armor = player.get_inventory(5)[1].grid
			for k, name in pairs (equipment) do
				armor.put({name = name})
			end
			for k, equipment in pairs (armor.equipment) do
				equipment.energy = equipment.max_energy
			end
		end
	else
		function give_starting_equipment(player)
			local items =
			{
				["iron-plate"] = math.floor(200*start_items_mult*(2/(1+start_items_mult))),
				["pipe"] = math.floor(200*start_items_mult*(2/(1+start_items_mult))),
				["pipe-to-ground"] = math.floor(50*start_items_mult*(2/(1+start_items_mult))),
				["copper-plate"] = math.floor(200*start_items_mult*(2/(1+start_items_mult))),
				["steel-plate"] = math.floor(200*start_items_mult*(2/(1+start_items_mult))),
				["iron-gear-wheel"] = math.floor(250*start_items_mult*(2/(1+start_items_mult))),
				["transport-belt"] = math.floor(600*start_items_mult*(1.5/(1.5+0.5*start_items_mult))),
				["underground-belt"] = math.floor(40*start_items_mult*(2/(1+start_items_mult))),
				["splitter"] = math.floor(40*start_items_mult*(2/(1+start_items_mult))),
				["wd-gun-turret"] = math.floor(8*start_items_mult),
				["stone-wall"] = math.floor(40*start_items_mult),
				["repair-pack"] = math.floor(20*start_items_mult*(2/(1+start_items_mult))),
				["inserter"] = math.floor(100*start_items_mult*(2/(1.5+0.5*start_items_mult))),
				["burner-inserter"] = 50,
				["small-electric-pole"] = 50,
				["medium-electric-pole"] = math.floor(50*start_items_mult*(2/(1+start_items_mult))),
			
				["big-electric-pole"] = 15,
				["burner-mining-drill"] = 50,
				["electric-mining-drill"] = math.floor(50*start_items_mult*(2/(1+start_items_mult))),
				["stone-furnace"] = 35,
				["steel-furnace"] = math.floor(20*start_items_mult*(2/(1+start_items_mult))),
				["electric-furnace"] = math.floor(8*start_items_mult),
				["assembling-machine-1"] = 50,
				["assembling-machine-2"] = math.floor(20*start_items_mult*(2/(1+start_items_mult))),
				["assembling-machine-3"] = math.floor(10*start_items_mult),
				["electronic-circuit"] = math.floor(200*start_items_mult*(2/(1+start_items_mult))),
				["fast-inserter"] = math.floor(100*start_items_mult*(2/(1.5+0.5*start_items_mult))),
				["long-handed-inserter"] = math.floor(100*start_items_mult*(2/(1+start_items_mult))),
				["substation"] = math.floor(10*start_items_mult*(2/(1+start_items_mult))),
				["boiler"] = 10,
				["offshore-pump"] = 1,
				["steam-engine"] = 20,
				["chemical-plant"] = 20,
				["oil-refinery"] = 5,
				["pumpjack"] = 10,
				["small-lamp"] = 20,
				["advanced-circuit"] = math.floor(10*start_items_mult),
				["stone-brick"] = math.floor(50*start_items_mult),
				
			}
				if start_items_mult >=2 then
			
					items["assembling-machine-1"]=nil
					items["stone-furnace"] = math.min(50,items["stone-furnace"])
			
				end
			
			insert_items(player, items)
		end
		
		function give_spawn_equipment(player)
			local items =
				{
				["steel-axe"] = 6,
				["submachine-gun"] = 1,
				["wd-yellow-ammo"] = math.floor(40*start_items_mult),
				["shotgun"] = 1,
				["shotgun-shell"] = 20,
				["power-armor"] = 1,
				["construction-robot"] = math.floor(20*start_items_mult),
				["blueprint"] = 1,
				["deconstruction-planner"] = 1
				}
			insert_items(player, items)
			local equipment =
				{
				"fusion-reactor-equipment",
			
				"exoskeleton-equipment",
				"personal-roboport-mk2-equipment",
				"personal-roboport-mk2-equipment",
				"night-vision-equipment",
				"battery-mk2-equipment"
				}
			local armor = player.get_inventory(5)[1].grid
			for k, name in pairs (equipment) do
				armor.put({name = name})
			end
			for k, equipment in pairs (armor.equipment) do
				equipment.energy = equipment.max_energy
			end
		end

	end

	
	function next_round_button_visible(bool)
	  for k, player in pairs (game.connected_players) do
		mod_gui.get_frame_flow(player).wave_frame.send_next_wave.style.visible = bool
	  end
	  global.round_button_visible = bool
	end

	function gui_init(player)
	  local gui = mod_gui.get_frame_flow(player)
	  if gui.wave_frame then
		gui.wave_frame.destroy()
	  end
	  create_wave_frame(gui)
	  local button_flow = mod_gui.get_button_flow(player)
	  local button = button_flow.wave_defense_visibility_button
	  if not button then
		button_flow.add
		{
		  type = "sprite-button",
		  name = "wave_defense_visibility_button",
		  style = mod_gui.button_style,
		  sprite = "entity/behemoth-spitter",
		  tooltip = {"visibility-button-tooltip"}
		}
	  end
	  local upgrade_button = button_flow.upgrade_button
	  if upgrade_button then upgrade_button.destroy() end
	  upgrade_button = button_flow.add{
		type = "sprite-button",
		name = "upgrade_button",
		caption = {"upgrade-button"},
		tooltip = {"upgrade-button-tooltip"},
		style = mod_gui.button_style
	  }
	  if gui.team_upgrade_frame then
		gui.team_upgrade_frame.destroy()
	  end
	end

	function create_wave_frame(gui)
	  if not gui.valid then return end
	  local frame = gui.add{type = "frame", name = "wave_frame", caption = {"wave-frame"}, direction = "vertical"}
	  frame.style.visible = true
	 
	  frame.add{type = "label", name = "current_wave", caption = {"current-wave", global.wave_number}}
	  frame.add{type = "label", name = "wave_hp", caption = {"",""}}
	  frame.add{type = "label", name = "next_level", caption = {"",""}}
	  frame.add{type = "label", name = "time_to_next_wave", caption = {"time-to-next-wave", time_to_next_wave()}}
	  local money_table = frame.add{type = "table", name = "money_table", column_count = 2}
	  money_table.add{type = "label", name = "force_money_label", caption = {"force-money"}}
	  local cash = money_table.add{type = "label", name = "force_money_count", caption = get_money()}.style
	  cash.font_color = {r = 0.8, b = 0.5, g = 0.8}
	  local button = frame.add
	  {
		type = "button",
		name = "send_next_wave",
		caption = {"send-next-wave"},
		tooltip = {"send-next-wave-tooltip"},
		style = "play_tutorial_button"
	  }
	  button.style.font = "default"
	  button.style.visible = global.round_button_visible
	end

	function create_upgrade_gui(gui)
	  local player = game.players[gui.player_index]
	  if gui.team_upgrade_frame then
		gui.team_upgrade_frame.destroy()
		return
	  end
	  local team_upgrades = gui.add{type = "frame", name = "team_upgrade_frame", caption = {"buy-upgrades"}, direction = "vertical"}
	  team_upgrades.style.visible = true
	  team_upgrades.style.title_bottom_padding = 2
	  local money_table = team_upgrades.add{type = "table", name = "money_table", column_count = 2}
	  money_table.style.column_alignments[2] = "right"
	  local label = money_table.add{type = "label", name = "force_money_label", caption = {"force-money"}}
	  label.style.font = "default-semibold"
	  local cash = money_table.add{type = "label", name = "force_money_count", caption = get_money()}.style
	  cash.font_color = {r = 0.8, b = 0.5, g = 0.8}
	  local scroll = team_upgrades.add{type = "scroll-pane", name = "team_upgrade_scroll"}
	  scroll.style.maximal_height = 450
	  local upgrade_table = scroll.add{type = "table", name = "upgrade_table", column_count = 2}
	  upgrade_table.style.horizontal_spacing = 0
	  upgrade_table.style.vertical_spacing = 0
	  update_upgrade_listing(upgrade_table, get_upgrades(), global.team_upgrades)
	  player.opened = team_upgrades
	end

	script.on_event(defines.events.on_gui_closed, function(event)
	  local gui = event.element
	  if not gui then return end
	  local name = gui.name
	  if not name then return end
	  if name == "team_upgrade_frame" then
		gui.destroy()
	  end
	end)

	function update_upgrade_listing(gui, array, upgrades)
	  for name, upgrade in pairs (array) do
		local level = upgrades[name]
		if not gui[name] then
		  local sprite = gui.add{type = "sprite-button", name = name, sprite = upgrade.sprite, tooltip = {"purchase"}, style = "play_tutorial_button"}
		  sprite.style.minimal_height = 75
		  sprite.style.minimal_width = 75
		  local flow = gui.add{type = "frame", name = name.."_flow", direction = "vertical"}
		  flow.style.maximal_height = 75
		  local another_table = flow.add{type = "table", name = name.."_label_table", column_count = 1}
		  another_table.style.vertical_spacing = 2
		  local label = another_table.add{type = "label", name = name.."_name", caption = {"", upgrade.caption, " "..upgrade.modifier}}
		  label.style.font = "default-bold"
		  another_table.add{type = "label", name = name.."_price", caption = {"upgrade-price", format_number(upgrade.price(level))}}
		  if not upgrade.hide_level then
			local level = another_table.add{type = "label", name = name.."_level", caption = {"upgrade-level", level}}
		  end
		else
		  gui[name.."_flow"][name.."_label_table"][name.."_price"].caption = {"upgrade-price", format_number(upgrade.price(level))}
		  if not upgrade.hide_level then
			gui[name.."_flow"][name.."_label_table"][name.."_level"].caption = {"upgrade-level", level}
		  end
		end
	  end
	end

	upgrade_research =
	{
	  ["bullet-damage"] = 2500,
	  ["bullet-speed"] = 1500,
	  ["shotgun-shell-damage"] = 1250,
	  ["shotgun-shell-speed"] = 2500,
	  ["flamethrower-damage"] = 22500,--7500
	  ["gun-turret-damage"] = 2000,
	  ["laser-turret-damage"] = 2500,
	  ["laser-turret-speed"] = 2250,
	  ["rocket-damage"] = 1000,
	  ["rocket-speed"] = 750,
	  ["grenade-damage"] = 1500,
	  ["follower-robot-count"] = 500,
	  ["combat-robot-damage"] = 1000,
	  ["mining-productivity"] = 750,
	  ["cannon-shell-damage"] = 500,
	  ["cannon-shell-speed"] = 250,
	}

	function get_upgrades()
	  local list = {}
	  local tech = game.forces["player"].technologies
	  for name, price in pairs (upgrade_research) do
		local append = name.."-1"
		if tech[append] then
		  local base = tech[append]
		  local upgrade = {}
		  local mod = base.effects[1].modifier
		  upgrade.modifier = "+"..tostring(mod*100).."%"
		  upgrade.price = function(x) return math.floor((1+x))*price end
		  upgrade.sprite = "technology/"..append
		  upgrade.caption = {"technology-name."..name}
		  upgrade.effect = {}
		  for k, effect in pairs (base.effects) do
			local type = effect.type
			if type == "ammo-damage" then
			  local cat = effect.ammo_category
			  upgrade.effect[k] = function(event)
				local force = game.players[event.player_index].force
				force.set_ammo_damage_modifier(cat, force.get_ammo_damage_modifier(cat)+mod)
				increment(global.team_upgrades, name)
				return true
			  end
			elseif type == "turret-attack" then
			  local id = effect.turret_id
			  upgrade.effect[k] = function(event)
				local force = game.players[event.player_index].force
				force.set_turret_attack_modifier(id, force.get_turret_attack_modifier(id)+mod)
				increment(global.team_upgrades, name)
				return true
			  end
			elseif type == "gun-speed" then
			  local cat = effect.ammo_category
			  upgrade.effect[k] = function(event)
				local force = game.players[event.player_index].force
				force.set_gun_speed_modifier(cat, force.get_gun_speed_modifier(cat)+mod)
				increment(global.team_upgrades, name)
				return true
			  end
			elseif type == "maximum-following-robots-count" then
			  upgrade.modifier = "+"..tostring(mod)
			  upgrade.effect[k] = function(event)
				local force = game.players[event.player_index].force
				increment(force, "maximum_following_robot_count", mod)
				increment(global.team_upgrades, name)
				return true
			  end
			elseif type == "mining-drill-productivity-bonus" then
			  upgrade.effect[k] = function(event)
				local force = game.players[event.player_index].force
				increment(force, "mining_drill_productivity_bonus", mod)
				increment(global.team_upgrades, name)
				return true
			  end
			else error(name.." - This tech has no relevant upgrade effect") end
		  end
		  list[name] = upgrade
		end
	  end
	  local bonus = {}
	  bonus.modifier = "+10%"
	  bonus.sprite = "technology/energy-shield-equipment"
	  bonus.price = function(x) return math.floor((1+x))*2500 end
	  bonus.effect = {}
	  bonus.effect[1] =  function (event)
		increment(global, "bounty_bonus", 0.1)
		increment(global.team_upgrades, "bounty_bonus")
		return true
	  end
	  bonus.caption = {"bounty-bonus"}
	  list["bounty_bonus"] = bonus
	  local sat = {}
	  sat.modifier = ""
	  sat.sprite = "technology/rocket-silo"
	  sat.price = function(x) return 150000+12500*global.send_satellite_round end
	  sat.hide_level = true
	  sat.effect = {}
	  sat.effect[1] = function(event)
		if not global.silo then error("No global silo") return end
		local inventory = global.silo.get_inventory(defines.inventory.rocket_silo_rocket)
		if inventory then
		  local contents = global.silo.get_inventory(defines.inventory.rocket_silo_rocket).get_contents()
		  if #contents == 0 then
			inventory.insert"satellite"
			game.print({"satellite-purchase", game.players[event.player_index].name})
			return false
		  end
		end
		increment(global, "money", 150000+12500*global.send_satellite_round)
		game.players[event.player_index].print({"satellite-refund"})
		return false
	  end
	  sat.caption = {"buy-satellite"}
	  list["buy-satellite"] = sat
	  return list
	end

	function get_money()
	  return format_number(global.money)
	end

	function update_connected_players()
	  local update_timer = function (gui, time_left, label)
		if not gui.wave_frame then return end
		if not gui.wave_frame.time_to_next_wave then return end
		local label = gui.wave_frame.time_to_next_wave
		if global.spawn_tick then
		  label.caption = {"time-to-wave-end", time_left}
		elseif global.wave_tick then
		  label.caption = {"time-to-next-wave", time_left}
		end
		if global.wave_number >= global.send_satellite_round then
		  label.caption = {"send-satellite"}
		end
	  end
	  local update_money_amounts = function(player)
		local wave_frame = mod_gui.get_frame_flow(player).wave_frame
		local money_table = wave_frame.money_table
		money_table.force_money_count.caption = get_money()
		local frame = player.gui.center.team_upgrade_frame
		if not frame then return end
		local money_table = frame.money_table
		money_table.force_money_count.caption = get_money()
	  end
	  local time_left
	  if global.spawn_tick then
		time_left = time_to_wave_end()
	  elseif global.wave_tick then
		time_left = time_to_next_wave()
	  else
		time_left = "Somethings gone wrong here... ?"
	  end
	  for k, player in pairs (game.connected_players) do
		update_timer(mod_gui.get_frame_flow(player), time_left, label)
		update_money_amounts(player.gui.center)
	  end
	end

	function update_round_number()
	  local update = function (gui, caption)
		if not gui.wave_frame then return end
		if not gui.wave_frame.current_wave then return end
		local label = gui.wave_frame.current_wave
		label.caption = caption
	  end
	  local caption = {"current-wave", global.wave_number}
	  for k, player in pairs (game.connected_players) do
		update(mod_gui.get_frame_flow(player), caption)
	  end

		if global.wave_number >= 20 then
	  
		  local update = function (gui, caption)
			if not gui.wave_frame then return end
			if not gui.wave_frame.wave_hp then return end
			local label = gui.wave_frame.wave_hp
			label.caption = caption
		  end
		  local caption = {"wave-hp", math.floor(((global.wave_number-16)*constant_difficulty+4000*math.pow(exponential_difficulty,global.wave_number-16))*difficulty)}
		  for k, player in pairs (game.connected_players) do
			update(mod_gui.get_frame_flow(player), caption)
		  end
		end
	end

	function set_research(force)
	  force.research_all_technologies()
	  local tech = force.technologies
	  for name in pairs (upgrade_research) do
		for i = 1, 20 do
		  local full_name = name.."-"..i
		  if tech[full_name] then
			tech[full_name].researched = false
		  end
		end
	  end
	  force.reset_technology_effects()
	  force.disable_research()
	end

	function set_recipes(force)
	  local recipes = force.recipes
	  local disable =
	  {
		"science-pack-1",
		"science-pack-2",
		"science-pack-3",
		"military-science-pack",
		"production-science-pack",
		"high-tech-science-pack",
		"lab",
		"firearm-magazine",
		"piercing-rounds-magazine",
		"uranium-rounds-magazine",
		"gun-turret",
		"lr-gun-turret"
	  }

	  recipes["wd-yellow-ammo"].enabled = true
	  recipes["wd-red-ammo"].enabled = true
	  recipes["wd-green-ammo"].enabled = true
	  recipes["wd-gun-turret"].enabled = true

	  for k, name in pairs (disable) do
		if recipes[name] then
		  recipes[name].enabled = false
		elseif name ~= "lr-gun-turret" then
		  error(name.." is not a valid recipe")
		end
	  end
	end
	
	
	if global.version == nil and version == nil then
	  --script.on_init(function()
	  init_globals()
	  setup_waypoints()
	  init_forces()
	  game.map_settings.pollution.enabled = false
	  randomize_ore()
	  for k, force in pairs (game.forces) do
	  	force.manual_crafting_speed_modifier = force.manual_crafting_speed_modifier+1.5
	  	force.character_inventory_slots_bonus = math.floor(start_items_mult-1 )*5
	  end
	  global.version = 10

	end
	
	script.on_configuration_changed(function()
		if global.version == nil then
			local temp = remote.call("wave-defense-unlimited", "get_interface")
			global.send_satellite_round = temp.send_satellite_round 
			global.wave_number = temp.wave_number 
			global.send_satellite_ticks = temp.send_satellite_ticks 
			global.skipped_multiplier = temp.skipped_multiplier 
			global.wave_tick = temp.wave_tick 
			global.money = temp.money 
			global.team_upgrades = temp.team_upgrades 
			global.on_tick_upgrade = temp.on_tick_upgrade 
			global.silo = temp.silo 
			global.force_bounty_modifier = temp.force_bounty_modifier 
			global.bounty_bonus = temp.bounty_bonus 
			global.round_button_visible = temp.round_button_visible 
			global.wave_power = temp.wave_power 
			global.spawn_tick = temp.spawn_tick 
			global.end_spawn_tick = temp.end_spawn_tick 
			global.spawns = temp.spawns 
			global.waypoints = temp.waypoints
			global.version = temp.version
		end

		global.on_tick_upgrade = 1
		if global.version == nil or global.version < 2 then
			if global.send_satellite_round == true then
				global.send_satellite_round = math.floor (global.wave_number/20)*20
			else
				global.send_satellite_round = math.floor (global.wave_number/20+1)*20
			end
			
			for k, player in pairs (game.connected_players) do
				if mod_gui.get_frame_flow(player).wave_frame and not mod_gui.get_frame_flow(player).wave_frame.wave_hp then
					mod_gui.get_frame_flow(player).wave_frame.add{type = "label", name = "wave_hp", caption = {"", ""}}
				end
			end
			global.version = 2
			global.on_tick_upgrade = global.on_tick_upgrade * 2
		end
		if global.version < 3 then
			for k, force in pairs (game.forces) do
				force.manual_crafting_speed_modifier = force.manual_crafting_speed_modifier+1
			end
			global.version = 3
		end
		if global.version < 8 then
			global.on_tick_upgrade = global.on_tick_upgrade *3
			for k, player in pairs (game.connected_players) do
				if mod_gui.get_frame_flow(player).wave_frame and not mod_gui.get_frame_flow(player).wave_frame.next_level then
					mod_gui.get_frame_flow(player).wave_frame.add{type = "label", name = "next_level", caption = {"", ""}}
				end
			end
			global.version = 8
		end
	
		if global.on_tick_upgrade == 1 then
			global.on_tick_upgrade = nil
		end
		global.version = 10
	end)

	script.on_event(defines.events.on_player_created, function(event)
	  local player = game.players[event.player_index]
	  player.teleport({x=-194,y=199})
	  give_spawn_equipment(player)
	  give_starting_equipment(player)

    end )
	
	script.on_event(defines.events.on_player_joined_game, function(event)
	  local player = game.players[event.player_index]
	  gui_init(player)
	  --migration 0.16.8
	  amount=player.get_inventory(defines.inventory.player_main).get_item_count("gun-turret")
	  amount=amount+player.get_inventory(defines.inventory.player_quickbar).get_item_count("gun-turret")
	  player.get_inventory(defines.inventory.player_main).remove({name="gun-turret",count=9999})
	  player.get_inventory(defines.inventory.player_quickbar).remove({name="gun-turret",count=9999})
	  if amount >0 then
		player.get_inventory(defines.inventory.player_main).insert({name="wd-gun-turret",count=math.max(1,amount)})
	  end
	end)
end